package com.xxfc.platform.vehicle.biz;



import com.github.wxiaoqi.security.common.biz.BaseBiz;
import com.github.wxiaoqi.security.common.exception.BaseException;
import com.github.wxiaoqi.security.common.util.process.ResultCode;
import com.xxfc.platform.vehicle.entity.VehicleExtension;
import com.xxfc.platform.vehicle.entity.VehiclePlatCata;;
import com.xxfc.platform.vehicle.mapper.VehicleEextensionMapper;
import com.xxfc.platform.vehicle.pojo.vo.VehicleExtensionVO;
import lombok.extern.slf4j.Slf4j;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import java.util.stream.Collectors;


@Service
@Slf4j
public class VehicleExtensionBiz extends BaseBiz<VehicleEextensionMapper, VehicleExtension>{

    @Autowired
    VehiclePlatCataBiz vehiclePlatCataBiz;




    @Transactional(rollbackFor = Exception.class)
    public  void   saveOrUpd(String  vehicleId,String extensionList){
        if (StringUtils.isBlank(vehicleId) || StringUtils.isBlank(extensionList)){
             throw  new BaseException("参数不能为空",ResultCode.FAILED_CODE);
        }
        List<Integer> list = Arrays.asList(extensionList.split(",")).parallelStream().map(s -> Integer.valueOf(s)).collect(Collectors.toList());
        List<Integer> ids=new ArrayList<>();
        if (list.size() > 0L){
            for (Integer extensionId:list){
                VehiclePlatCata vehiclePlatCata = vehiclePlatCataBiz.selectById(extensionId);
                if (vehiclePlatCata == null ){
                     continue;
                }
                VehicleExtension vehicleExtension=new VehicleExtension();
                vehicleExtension.setCataId(extensionId);
                vehicleExtension.setVehicleId(vehicleId);
                vehicleExtension.setIsDel(0);
                VehicleExtension vehicleExtension1=selectOne(vehicleExtension);
                Integer id;
                if (vehicleExtension1 == null){
                    vehicleExtension.setParentCataId(vehiclePlatCata.getParentId());
                    insertSelective(vehicleExtension);
                    id=vehicleExtension.getId();
                }else {
                    id=vehicleExtension1.getId();
                }
                ids.add(id);
            }
        }
        mapper.delByIds(ids,vehicleId);
    }


    public List<VehicleExtensionVO>  selectList(String vehicleId){
        return mapper.selectList(vehicleId);
    }

    public List<VehicleExtensionVO>  selectListByApply(List<Integer> cataIds){
        return  mapper.selectListByApply(cataIds);
    }


    public List<VehicleExtensionVO>  getTree(String vehicleId){
        List<VehicleExtensionVO> vehicleExtensionVOS = mapper.selectListByParent(vehicleId);
        if (vehicleExtensionVOS.size() > 0){
            for (VehicleExtensionVO extensionVO:vehicleExtensionVOS) {
                extensionVO.setChildren(selectList(vehicleId));
            }
        }
        return  vehicleExtensionVOS;

    }


    public List<VehicleExtensionVO>  getTreeByApply(List<Integer> cataIds){
        List<VehicleExtensionVO> vehicleExtensionVOS = mapper.selectListByApplyParent(cataIds);
        if (vehicleExtensionVOS.size() > 0){
            for (VehicleExtensionVO extensionVO:vehicleExtensionVOS) {
                extensionVO.setChildren(selectListByApply(cataIds));
            }
        }
        return  vehicleExtensionVOS;

    }













}
